//
//  BlockTests.swift
//  Tetris
//
//  Created by Santiago Pavón Gómez on 11/8/16.
//  Copyright © 2016 UPM. All rights reserved.
//

import XCTest
@testable import Tetris

class BlockTests: XCTestCase {
    
    override func setUp() {
        super.setUp()
        // Put setup code here. This method is called before the invocation of each test method in the class.
    }
    
    override func tearDown() {
        // Put teardown code here. This method is called after the invocation of each test method in the class.
        super.tearDown()
    }

    //----
    
    func testRotateNShape0() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape0, rotation: .n)
        XCTAssertEqual(b.width, 3, "Mal el ancho de shape0 rotada N.")
        XCTAssertEqual(b.height, 4, "Mal el ancho de shape0 rotada N.")
        XCTAssertEqual(b.topEdge, 0, "Mal el top edge de shape0 rotada N.")
        XCTAssertEqual(b.leftEdge, 1, "Mal el left edge de shape0 rotada N.")
        XCTAssertEqual(b.bottomEdge, 3, "Mal el bottom edge de shape0 rotada N.")
        XCTAssertEqual(b.rightEdge, 1, "Mal el right edge de shape0 rotada N.")
    }

    func testRotateEShape0() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape0, rotation: .e)
        XCTAssertEqual(b.width, 4, "Mal el ancho de shape0 rotada E.")
        XCTAssertEqual(b.height, 3, "Mal el ancho de shape0 rotada E.")
        XCTAssertEqual(b.topEdge, 1, "Mal el top edge de shape0 rotada E.")
        XCTAssertEqual(b.leftEdge, 0, "Mal el left edge de shape0 rotada E.")
        XCTAssertEqual(b.bottomEdge, 1, "Mal el bottom edge de shape0 rotada E.")
        XCTAssertEqual(b.rightEdge, 3, "Mal el right edge de shape0 rotada E.")
    }
    
    
    func testRotateSShape0() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape0, rotation: .s)
        XCTAssertEqual(b.width, 3, "Mal el ancho de shape0 rotada S.")
        XCTAssertEqual(b.height, 4, "Mal el ancho de shape0 rotada S.")
        XCTAssertEqual(b.topEdge, 0, "Mal el top edge de shape0 rotada S.")
        XCTAssertEqual(b.leftEdge, 1, "Mal el left edge de shape0 rotada S.")
        XCTAssertEqual(b.bottomEdge, 3, "Mal el bottom edge de shape0 rotada S.")
        XCTAssertEqual(b.rightEdge, 1, "Mal el right edge de shape0 rotada S.")
    }
    
    func testRotateWShape0() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape0, rotation: .w)
        XCTAssertEqual(b.width, 4, "Mal el ancho de shape0 rotada W.")
        XCTAssertEqual(b.height, 3, "Mal el ancho de shape0 rotada W.")
        XCTAssertEqual(b.topEdge, 1, "Mal el top edge de shape0 rotada W.")
        XCTAssertEqual(b.leftEdge, 0, "Mal el left edge de shape0 rotada W.")
        XCTAssertEqual(b.bottomEdge, 1, "Mal el bottom edge de shape0 rotada W.")
        XCTAssertEqual(b.rightEdge, 3, "Mal el right edge de shape0 rotada W.")
    }
    
    //----
    
    func testRotateNShape2() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape2, rotation: .n)
        XCTAssertEqual(b.width, 3, "Mal el ancho de shape2 rotada N.")
        XCTAssertEqual(b.height, 3, "Mal el ancho de shape2 rotada N.")
        XCTAssertEqual(b.topEdge, 0, "Mal el top edge de shape2 rotada N.")
        XCTAssertEqual(b.leftEdge, 0, "Mal el left edge de shape2 rotada N.")
        XCTAssertEqual(b.bottomEdge, 1, "Mal el bottom edge de shape2 rotada N.")
        XCTAssertEqual(b.rightEdge, 2, "Mal el right edge de shape2 rotada N.")
    }
    
    func testRotateEShape2() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape2, rotation: .e)
        XCTAssertEqual(b.width, 3, "Mal el ancho de shape2 rotada E.")
        XCTAssertEqual(b.height, 3, "Mal el ancho de shape2 rotada E.")
        XCTAssertEqual(b.topEdge, 0, "Mal el top edge de shape2 rotada E.")
        XCTAssertEqual(b.leftEdge, 1, "Mal el left edge de shape2 rotada E.")
        XCTAssertEqual(b.bottomEdge, 2, "Mal el bottom edge de shape2 rotada E.")
        XCTAssertEqual(b.rightEdge, 2, "Mal el right edge de shape2 rotada E.")
    }
    
    
    func testRotateSShape2() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape2, rotation: .s)
        XCTAssertEqual(b.width, 3, "Mal el ancho de shape2 rotada S.")
        XCTAssertEqual(b.height, 3, "Mal el ancho de shape2 rotada S.")
        XCTAssertEqual(b.topEdge, 1, "Mal el top edge de shape2 rotada S.")
        XCTAssertEqual(b.leftEdge, 0, "Mal el left edge de shape2 rotada S.")
        XCTAssertEqual(b.bottomEdge, 2, "Mal el bottom edge de shape2 rotada S.")
        XCTAssertEqual(b.rightEdge, 2, "Mal el right edge de shape2 rotada S.")
    }
    
    func testRotateWShape2() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape2, rotation: .w)
        XCTAssertEqual(b.width, 3, "Mal el ancho de shape2 rotada W.")
        XCTAssertEqual(b.height, 3, "Mal el ancho de shape2 rotada W.")
        XCTAssertEqual(b.topEdge, 0, "Mal el top edge de shape2 rotada W.")
        XCTAssertEqual(b.leftEdge, 0, "Mal el left edge de shape2 rotada W.")
        XCTAssertEqual(b.bottomEdge, 2, "Mal el bottom edge de shape2 rotada W.")
        XCTAssertEqual(b.rightEdge, 1, "Mal el right edge de shape2 rotada W.")
    }
    
    /*
    func testRotateWShape0() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape0, rotation: .w)
        
        XCTAssertEqual(b.anchor().x, 1, "Mal anchor.x al rotar a W.")
        XCTAssertEqual(b.anchor().y, 0, "Mal anchor.y al rotar a W.")
    }
    
    func testRotateSShape0() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
        
        let b = Block(shape: Shape.shape0, rotation: .s)
        
        XCTAssertEqual(b.anchor().x, 0, "Mal anchor.x al rotar a S.")
        XCTAssertEqual(b.anchor().y, 2, "Mal anchor.y al rotar a S.")
    }
    */
    
    func testExample() {
        // This is an example of a functional test case.
        // Use XCTAssert and related functions to verify your tests produce the correct results.
    }
    
    func testPerformanceExample() {
        // This is an example of a performance test case.
        self.measure {
            // Put the code you want to measure the time of here.
        }
    }
    
}
